package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.model.AnswerEntity;
import com.rf.psychological.dao.model.DimensionEntity;
import com.rf.psychological.scale.dao.model.ScaleMarksEntity;

import java.text.DecimalFormat;
import java.util.*;

/**
 * @author lhl
 * @description: 道路安全的家庭氛围量表
 * @date 2021/10/31
 */
public class FCRSSScale extends BaseScale {
    public FCRSSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }
    public JSONObject scaleCalculate() throws Exception{
        //总分
        double score = 0;
        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String,String>> resultMapList = new ArrayList<>();
        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        Map<String,Double> dimensionScoreMap = new HashMap<>();
        if (dimensionEntities.size() > 0){
            //计算每个维度得分

            double[] dimensionScore = new double[dimensionEntities.size()];
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject1 = jsonArray.getJSONObject(i);
                for (int y = 0; y < dimensionEntities.size(); y++) {
                    //for (DimensionEntity dimensionEntity:dimensionEntities){
                    DimensionEntity dimensionEntity = dimensionEntities.get(y);
                    String questionNos = dimensionEntity.getQuestionNo();
                    String[] questionNo = questionNos.split("；");
                    for (String question:questionNo){
                        if (question.equals(jsonObject1.getString("questionNo"))){
                            for (AnswerEntity answerEntity:answerEntities){
                                ///只用比较选项内容，进而判定该题目的分数值
                                if (answerEntity.getQuestionNo().equals(question) &&answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                                    dimensionScore[y] += Double.valueOf(answerEntity.getScore());
                                }
                            }
                            break;
                        }
                    }
                }
               /* //计算总分
                for (AnswerEntity answerEntity:answerEntities){
                    if (answerEntity.getQuestionNo().equals(String.valueOf(i+1))){
                        if (answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                            score += Integer.valueOf(answerEntity.getScore());
                        }
                    }
                }*/
            }

           /* resultMap0.put("GDMS总分", String.valueOf(score));
            resultJson.put("GDMS总分", String.valueOf(score));*/
            //计算每个维度的平均分
            DecimalFormat df = new DecimalFormat("######0.00");
            double[] Mdscore = new double[dimensionScore.length];
            for (int i = 0; i < dimensionScore.length; i++) {
                Mdscore[i]= Double.parseDouble(df.format(dimensionScore[i]/6.0));
            }




            resultMap0.put("反馈维度均分", String.valueOf(Mdscore[0]));
            resultMap0.put("无承诺维度均分", String.valueOf(Mdscore[1]));
            resultMap0.put("榜样维度均分", String.valueOf(Mdscore[2]));
            resultMap0.put("监控维度均分", String.valueOf(Mdscore[3]));
            resultMap0.put("限制维度均分", String.valueOf(Mdscore[4]));
            resultMap0.put("沟通维度均分", String.valueOf(Mdscore[5]));

            resultJson.put("反馈维度均分", String.valueOf(Mdscore[0]));
            resultJson.put("无承诺维度均分", String.valueOf(Mdscore[1]));
            resultJson.put("榜样维度均分", String.valueOf(Mdscore[2]));
            resultJson.put("监控维度均分", String.valueOf(Mdscore[3]));
            resultJson.put("限制维度均分", String.valueOf(Mdscore[4]));
            resultJson.put("沟通维度均分", String.valueOf(Mdscore[5]));

            dimensionScoreMap.put("2c91f37d7bec0878017c4135dfe53979", Mdscore[0]);
            dimensionScoreMap.put("2c91f37d7bec0878017c4135e01a397a", Mdscore[1]);
            dimensionScoreMap.put("2c91f37d7bec0878017c4135e04f397b", Mdscore[2]);
            dimensionScoreMap.put("2c91f37d7bec0878017c4135e084397c", Mdscore[3]);
            dimensionScoreMap.put("2c91f37d7bec0878017c4135e0b9397d", Mdscore[4]);
            dimensionScoreMap.put("2c91f37d7bec0878017c4135e0ed397e", Mdscore[5]);

            resultJson.put("dimensionScoreMap",dimensionScoreMap);
            resultMapList.add(resultMap0);
        }

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",resultJson.getString("scaleName"));
        returnJson.put("resultJson",resultJson);

        return returnJson;

    }

}
